???File Path
==========
***...\Src\Assets\AssetsMaster.cs\n\n\n

???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Assets;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllAssetsMasterBaseData()
            {
                List<MdlBaseIntId> lstMdlAssetsMasterBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_assets_master()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_assets_master_id"]) ? (long)Convert.ToUInt64(objRecord["pk_assets_master_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord["sin_in_code_set_branch_code"]) ? Convert.ToString(objRecord["sin_in_code_set_branch_code"]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strName;
        
                        lstMdlAssetsMasterBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlAssetsMasterBaseIntId;
            }
        


            public List<MdlAssetsMaster> FnGetAllAssetsMasterWithActionUser()
            {
                List<MdlAssetsMaster> lstMdlAssetsMaster = new List<MdlAssetsMaster>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_assets_master_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlAssetsMaster mdlAssetsMaster = new MdlAssetsMaster();

                        
				mdlAssetsMaster.binAssetsMasterId = (DBNull.Value != objRecord["pk_assets_master_id"]) ? (long)Convert.ToInt64(objRecord["pk_assets_master_id"]) : mdlAssetsMaster.binAssetsMasterId;

				mdlAssetsMaster.binAccountId = (DBNull.Value != objRecord["fk_account_id"]) ? (long)Convert.ToInt64(objRecord["fk_account_id"]) : mdlAssetsMaster.binAccountId;
				mdlAssetsMaster.binAdCrAccountId = (DBNull.Value != objRecord["fk_ad_cr_account_id"]) ? (long)Convert.ToInt64(objRecord["fk_ad_cr_account_id"]) : mdlAssetsMaster.binAdCrAccountId;
				mdlAssetsMaster.binDepreciationDrAccountId = (DBNull.Value != objRecord["fk_depreciation_dr_account_id"]) ? (long)Convert.ToInt64(objRecord["fk_depreciation_dr_account_id"]) : mdlAssetsMaster.binDepreciationDrAccountId;
				mdlAssetsMaster.sinDepreciationBasedOn = (DBNull.Value != objRecord["sin_depreciation_based_on"]) ? (short)Convert.ToInt16(objRecord["sin_depreciation_based_on"]) : mdlAssetsMaster.sinDepreciationBasedOn;
				mdlAssetsMaster.dblDepreciationPerc = (DBNull.Value != objRecord["dbl_depreciation_perc"]) ? (double)Convert.ToDouble(objRecord["dbl_depreciation_perc"]) : mdlAssetsMaster.dblDepreciationPerc;

				mdlAssetsMaster.sinInCodeSetBranchCode = (DBNull.Value != objRecord["sin_in_code_set_branch_code"]) ? (short)Convert.ToInt16(objRecord["sin_in_code_set_branch_code"]) : mdlAssetsMaster.sinInCodeSetBranchCode;
				mdlAssetsMaster.strCodePrefix = (DBNull.Value != objRecord["vhr_code_prefix"]) ? Convert.ToString(objRecord["vhr_code_prefix"]) : mdlAssetsMaster.strCodePrefix;
				mdlAssetsMaster.binCodePartLastNumber = (DBNull.Value != objRecord["bin_code_part_last_number"]) ? (long)Convert.ToInt64(objRecord["bin_code_part_last_number"]) : mdlAssetsMaster.binCodePartLastNumber;


        
                        lstMdlAssetsMaster.Add(mdlAssetsMaster);
                    }
                }

                return lstMdlAssetsMaster;
            }
        


            public MdlResAssetsMaster FnInsertOrUpdateAssetsMaster(MdlReqAssetsMaster mdlReqAssetsMaster)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqAssetsMaster.mdlAssetsMaster.binAssetsMasterId == 0)
                {
                    mdlReqAssetsMaster.mdlAssetsMaster.intSysActionId = 0;
                    mdlReqAssetsMaster.mdlAssetsMaster.binCreatedUserId = mdlReqAssetsMaster.linLoginUserId;
                    mdlReqAssetsMaster.mdlAssetsMaster.strCreatedUser = mdlReqAssetsMaster.strLoginUserName;
                    mdlReqAssetsMaster.mdlAssetsMaster.dtmCreated = mdlReqAssetsMaster.dtmCurrentDateTime;
                }
                else {
                    mdlReqAssetsMaster.mdlAssetsMaster.binLastModifiedUserId = mdlReqAssetsMaster.linLoginUserId;
                    mdlReqAssetsMaster.mdlAssetsMaster.strLastModifiedUser = mdlReqAssetsMaster.strLoginUserName;
                    mdlReqAssetsMaster.mdlAssetsMaster.dtmLastModified = mdlReqAssetsMaster.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlAssetsMaster", NpgsqlDbType.Jsonb) { Value = mdlReqAssetsMaster.mdlAssetsMaster, DataTypeName = "jsnAssetsMaster"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_assetsMaster(:mdlAssetsMaster, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSMASTER.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSMASTER.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSMASTER.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResAssetsMaster mdlResAssetsMaster = new MdlResAssetsMaster();
                mdlResAssetsMaster.mdlAssetsMaster = mdlAssetsMasterReq.mdlAssetsMaster;
                if (mdlReqAssetsMaster.mdlAssetsMaster.binAssetsMasterId == 0)
                {
                    mdlResAssetsMaster.mdlAssetsMaster.binAssetsMasterId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResAssetsMaster.mdlAssetsMaster.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResAssetsMaster.mdlAssetsMaster.intSysActionId += 1;
                    mdlResAssetsMaster.mdlAssetsMaster.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResAssetsMaster.sinStatus = 1;
                mdlResAssetsMaster.strStatusCode = "SUCCESS";
                mdlResAssetsMaster.strMessage = "ASSETSMASTER has been Saved.";
                
                return mdlResAssetsMaster;
            } 
        


            public MdlResBaseIntId FnDeleteAssetsMaster(MdlReqBaseIntId mdlReqAssetsMasterBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binAssetsMasterId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsMasterBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binAssetsMasterId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqAssetsMasterBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqAssetsMasterBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_assetsMaster(:binAssetsMasterId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSMASTER.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSMASTER.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "ASSETSMASTER.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResAssetsMasterIntId = new MdlResBaseIntId();

                mdlResAssetsMasterIntId.mdlBaseIntId = mdlReqAssetsMasterBaseIntId.mdlBaseIntId;
                mdlResAssetsMasterIntId.sinStatus = 1;
                mdlResAssetsMasterIntId.strStatusCode = "SUCCESS";
                mdlResAssetsMasterIntId.strMessage = "ASSETSMASTER has been deleted.";

                return mdlResAssetsMasterIntId;
            }
        

